%define prefix /usr/kerberos

Summary: Kerberos Authentication System
Name: krb5
Version: 1.1.1
Release: 9
Source0: krb5-%{version}.src.tar.gz
Source1: krb5-%{version}.crypto.tar.gz
Source2: krb5-%{version}.doc.tar.gz
Source3: krb5server.init
Source4: krb5.conf
Source5: krb5.sh
Source6: krb5.csh
Source7: kdcrotate
Source8: kdc.conf
Source9: kadm5.acl
Source10: krsh
Source11: krlogin
Patch0: krb5-1.1-krb4.patch
Patch1: krb5-1.1-db.patch
Patch2: krb5-1.1.1-tiocgltc.patch
Patch3: krb5-1.1.1-libpty.patch
Patch4: krb5-1.1.1-fixinfo.patch
Patch5: krb5-1.1.1-manpages.patch
Patch6: krb5-1.1.1-formatstring.patch
Patch7: krb5-1.1.1-netkitr.patch
Copyright: MIT, freely distributable.
URL: http://web.mit.edu/kerberos/www/
Group: System Environment/Libraries
BuildRoot: %{_tmppath}/%{name}-root
Prereq: grep info
BuildPrereq: e2fsprogs-devel tcl texinfo

%changelog
* Wed Mar 08 2000 Nalin Dahyabhai <nalin@redhat.com>
- Don't enable the server by default.
- Compress info pages.
- Add defaults for the PAM module to krb5.conf

* Mon Mar 06 2000 Nalin Dahyabhai <nalin@redhat.com>
- Correct copyright: it's exportable now, provided the proper paperwork is
  filed with the government.

* Fri Mar 03 2000 Nalin Dahyabhai <nalin@redhat.com>
- apply Mike Friedman's patch to fix format string problems
- don't strip off argv[0] when invoking regular rsh/rlogin

* Thu Mar 02 2000 Nalin Dahyabhai <nalin@redhat.com>
- run kadmin.local correctly at startup

* Mon Feb 28 2000 Nalin Dahyabhai <nalin@redhat.com>
- pass absolute path to kadm5.keytab if/when extracting keys at startup

* Sat Feb 19 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix info page insertions

* Wed Feb  9 2000 Nalin Dahyabhai <nalin@redhat.com>
- tweak man pages to automatically extract kadm5 keys if
  /var/kerberos/krb5kdc/kadm5.keytab doesn't exist yet
- adjust package descriptions

* Thu Feb  3 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix for potentially gzipped man pages

* Fri Jan 21 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix comments in krb5-configs

* Fri Jan  7 2000 Nalin Dahyabhai <nalin@redhat.com>
- move /usr/kerberos/bin to end of PATH

* Tue Dec 28 1999 Nalin Dahyabhai <nalin@redhat.com>
- install kadmin header files

* Tue Dec 21 1999 Nalin Dahyabhai <nalin@redhat.com>
- patch around TIOCGTLC defined on alpha and remove warnings from libpty.h
- add installation of info docs
- remove krb4 compat patch because it doesn't fix workstation-side servers

* Mon Dec 20 1999 Nalin Dahyabhai <nalin@redhat.com>
- remove hesiod dependency at build-time

* Sun Dec 19 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- rebuild on 1.1.1

* Thu Oct  7 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- clean up init script for server, verify that it works [jlkatz]
- clean up rotation script so that rc likes it better
- add %clean stanza

* Mon Oct  4 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- backed out ncurses and makeshlib patches
- update for krb5-1.1
- add KDC rotation to rc.boot, based on ideas from Michael's C version

* Mon Sep 26 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- added -lncurses to telnet and telnetd makefiles

* Mon Jul  5 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- added krb5.csh and krb5.sh to /etc/profile.d

* Mon Jun 22 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- broke out configuration files

* Mon Jun 14 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- fixed server package so that it works now

* Sat May 15 1999 Nalin Dahyabhai <nsdahya1@eos.ncsu.edu>
- started changelog
- updated existing 1.0.5 RPM from Eos Linux to krb5 1.0.6
- added --force to makeinfo commands to skip errors during build

%package configs
Summary: Kerberos 5 sample configuration file(s).
Group: System Environment/Base

%description configs
Kerberos V5 is a trusted-third-party authentication system.  This package
contains sample configuration files for Kerberos 5 clients.

%package workstation
Summary: Kerberos 5 programs for use on workstations.
Group: System Environment/Base
Requires: krb5-libs

%description
Kerberos V5 is a trusted-third-party authentication system.  Kerberos is
named for the three-headed watchdog from Greek mythology who guarded the
entrance to the underworld.

%description workstation
Kerberos V5 is a trusted-third-party authentication system.  Kerberos is
named for the three-headed watchdog from Greek mythology who guarded the
entrance to the underworld.  This package contains the basic Kerberos
programs (kinit, klist, kdestroy, kpasswd) as well as kerberized versions
of telnet and ftp.  Most people should install this package.

%package server
Group: System Environment/Daemons
Summary: Kerberos 5 server programs.
Requires: krb5-libs krb5-workstation
%description server
Kerberos V5 is a trusted-third-party authentication system.  Kerberos is
named for the three-headed watchdog from Greek mythology who guarded
the entrance to the underworld.  This package contains the Kerberos 5
server programs.  Most people should NOT install this package.

%package libs
Summary: Kerberos 5 shared libraries.
Group: System Environment/Libraries
Requires: /etc/krb5.conf
%description libs
Kerberos V5 is a trusted-third-party authentication system.  Kerberos is
named for the three-headed watchdog from Greek mythology who guarded
the entrance to the underworld.  This package contains the Kerberos 5 shared
libraries.  Most people should install this package.

%package devel
Summary: Header files and libraries necessary to compile Kerberos 5 programs.
Group: Development/Libraries
Requires: krb5-libs
%description devel
Kerberos V5 is a trusted-third-party authentication system.  Kerberos is
named for the three-headed watchdog from Greek mythology who guarded
the entrance to the underworld.  If you want to develop Kerberos-aware
programs, then you'll need to install this package.

%prep
%setup -q -b 1 -b 2
#%patch0
%patch1 -p0 -b .db
%patch2 -p0 -b .tciogltc
%patch3 -p0 -b .libpty
%patch4 -p0 -b .fixinfo
%patch5 -p0 -b .manpages
%patch6 -p0 -b .friedman
%patch7 -p0 -b .netkitr
find . -type f -name "*.fixinfo" -exec rm -fv "{}" ";"

%build
cd src
CFLAGS="$RPM_OPT_FLAGS" \
	./configure --prefix=%{prefix} \
	--enable-shared --enable-static \
	--with-tcl=/usr \
	--with-netlib=-lresolv \
	--localstatedir=/var/kerberos \
	--infodir=/usr/info \
	--with-krb4 %{_target_platform}
make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{prefix}/bin
install -m 755 $RPM_SOURCE_DIR/{krsh,krlogin} $RPM_BUILD_ROOT/%{prefix}/bin/

mkdir -p $RPM_BUILD_ROOT%{prefix}/include
(cd src/include
 find kadm5 krb5 gssrpc gssapi -name "*.h" | \
 cpio -pdm  $RPM_BUILD_ROOT/%{prefix}/include )
sed 's^k5-int^krb5/kdb^g' < $RPM_BUILD_ROOT/%{prefix}/include/kadm5/admin.h \
			  > $RPM_BUILD_ROOT/%{prefix}/include/kadm5/admin.h2
mv $RPM_BUILD_ROOT/%{prefix}/include/kadm5/admin.h2 \
   $RPM_BUILD_ROOT/%{prefix}/include/kadm5/admin.h
find $RPM_BUILD_ROOT/%{prefix}/include -type d | xargs chmod 755
find $RPM_BUILD_ROOT/%{prefix}/include -type f | xargs chmod 755


mkdir -p $RPM_BUILD_ROOT/usr/info
install -m 644 doc/*.info* $RPM_BUILD_ROOT/usr/info
gzip $RPM_BUILD_ROOT/usr/info/*.info*

mkdir -p $RPM_BUILD_ROOT/var/kerberos/krb5kdc
install -m 644 $RPM_SOURCE_DIR/kdc.conf  $RPM_BUILD_ROOT/var/kerberos/krb5kdc/
install -m 644 $RPM_SOURCE_DIR/kadm5.acl $RPM_BUILD_ROOT/var/kerberos/krb5kdc/

mkdir -p $RPM_BUILD_ROOT/etc/profile.d
install -m 644 $RPM_SOURCE_DIR/krb5.conf $RPM_BUILD_ROOT/etc/krb5.conf
install -m 755 $RPM_SOURCE_DIR/krb5.{sh,csh} $RPM_BUILD_ROOT/etc/profile.d/

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 $RPM_SOURCE_DIR/krb5server.init $RPM_BUILD_ROOT/etc/rc.d/init.d/krb5server
install -m 755 $RPM_SOURCE_DIR/kdcrotate $RPM_BUILD_ROOT/etc/rc.d/init.d/

cd src
make prefix=$RPM_BUILD_ROOT%{prefix} \
	localstatedir=$RPM_BUILD_ROOT/var/kerberos \
	infodir=$RPM_BUILD_ROOT/usr/info install

chmod 755 $RPM_BUILD_ROOT%{prefix}/lib/*.so*

%post libs
#if [ -r /etc/services ] ; then

#grep -q ^kerberos        /etc/services || cat >> /etc/services << EOF
#kerberos        88/udp          kdc             # Kerberos authentication--udp
#kerberos        88/tcp          kdc             # Kerberos authentication--tcp
#EOF
#grep -q ^kerberos-sec    /etc/services || cat >> /etc/services << EOF
#kerberos-sec    750/udp                         # Kerberos authentication--udp
#kerberos-sec    750/tcp                         # Kerberos authentication--tcp
#EOF
#grep -q ^kerberos_master /etc/services || cat >> /etc/services << EOF
#kerberos_master 751/udp                         # Kerberos authentication
#kerberos_master 751/tcp                         # Kerberos authentication
#EOF
#grep -q ^kerberos-adm    /etc/services || cat >> /etc/services << EOF
#kerberos-adm    749/tcp                         # Kerberos 5 admin/changepw
#kerberos-adm    749/udp                         # Kerberos 5 admin/changepw
#EOF
#grep -q ^kpop            /etc/services || cat >> /etc/services << EOF
#kpop            1109/tcp                        # Pop with Kerberos
#EOF
#grep -q ^kshell          /etc/services || cat >> /etc/services << EOF
#kshell          544/tcp         cmd             # and remote shell
#EOF
#grep -q ^klogin          /etc/services || cat >> /etc/services << EOF
#klogin          543/tcp                         # Kerberos authenticated rlogin
#EOF
#grep -q ^eklogin         /etc/services || cat >> /etc/services << EOF
#eklogin         2105/tcp                        # Kerberos encrypted rlogin
#EOF
#grep -q ^krb5_prop       /etc/services || cat >> /etc/services << EOF
#krb5_prop       754/tcp                         # Kerberos slave propagation
#EOF
#grep -q ^krb524          /etc/services || cat >> /etc/services << EOF
#krb524          4444/tcp                        # Kerberos 5 to 4 ticket xlator
#EOF

#fi

 grep -q %{prefix}/lib /etc/ld.so.conf || echo %{prefix}/lib >> /etc/ld.so.conf
 /sbin/ldconfig

%postun libs
/sbin/ldconfig

%post server
#/sbin/chkconfig --add krb5server
/sbin/install-info /usr/info/krb425.info.gz /usr/info/dir
/sbin/install-info /usr/info/krb5-admin.info.gz /usr/info/dir
/sbin/install-info /usr/info/krb5-install.info.gz /usr/info/dir

%preun server
if [ "$1" = "0" ] ; then
	/sbin/chkconfig --del krb5server
	/sbin/install-info --delete /usr/info/krb425.info.gz /usr/info/dir
	/sbin/install-info --delete /usr/info/krb5-admin.info.gz /usr/info/dir
	/sbin/install-info --delete /usr/info/krb5-install.info.gz /usr/info/dir
fi

%post workstation
/sbin/install-info /usr/info/krb5-user.info /usr/info/dir

#if [ -f /etc/inetd.conf ] ; then
# Install additional services for inetd to start.
#grep -q ^telnet  /etc/inetd.conf || cat >> /etc/inetd.conf << EOF
#telnet  stream  tcp  nowait  root /usr/kerberos/sbin/telnetd    telnetd
#EOF
#grep -q ^ftp     /etc/inetd.conf || cat >> /etc/inetd.conf << EOF
#ftp     stream  tcp  nowait  root /usr/kerberos/sbin/ftpd       ftpd -l -a
#EOF

#grep -q klogin  /etc/inetd.conf || cat >> /etc/inetd.conf << EOF
#klogin  stream  tcp  nowait  root /usr/kerberos/sbin/klogind    klogind -5
#EOF
#grep -q eklogin /etc/inetd.conf || cat >> /etc/inetd.conf << EOF
#eklogin stream  tcp  nowait  root /usr/kerberos/sbin/klogind    klogind -5 -e
#EOF
#grep -q kshell  /etc/inetd.conf || cat >> /etc/inetd.conf << EOF
#kshell  stream  tcp  nowait  root /usr/kerberos/sbin/kshd       kshd -5 -e
#EOF

#fi

%preun workstation
if [ "$1" = "0" ] ; then
	/sbin/install-info --delete /usr/info/krb5-user.info /usr/info/dir
fi

%post configs
#/sbin/chkconfig --add kdcrotate

%preun configs
if [ "$1" = "0" ] ; then
	/sbin/chkconfig --del kdcrotate
fi

%files workstation
%defattr(-,root,root)
%config /etc/profile.d/krb5.sh
%config /etc/profile.d/krb5.csh
%doc doc/user*.html doc/user*.ps src/config-files/services.append
/usr/info/krb5-user.info*
%{prefix}/bin/kdestroy
%{prefix}/man/man1/kdestroy.1*
%{prefix}/bin/ftp
%{prefix}/man/man1/ftp.1*
%{prefix}/bin/kinit
%{prefix}/man/man1/kinit.1*
%{prefix}/bin/klist
%{prefix}/man/man1/klist.1*
%{prefix}/bin/kpasswd
%{prefix}/man/man1/kpasswd.1*
%{prefix}/sbin/kadmin
%{prefix}/man/man8/kadmin.8*
%{prefix}/sbin/ktutil
%{prefix}/man/man8/ktutil.8*
%{prefix}/bin/krb524init
%{prefix}/bin/gss-client
%{prefix}/bin/ksu
%{prefix}/man/man1/ksu.1*
%{prefix}/bin/rcp
%{prefix}/man/man1/rcp.1*
%{prefix}/bin/krlogin
%{prefix}/bin/rlogin
%{prefix}/man/man1/rlogin.1*
%{prefix}/bin/krsh
%{prefix}/bin/rsh
%{prefix}/man/man1/rsh.1*
%{prefix}/bin/telnet
%{prefix}/man/man1/telnet.1*
%{prefix}/bin/v4rcp
%{prefix}/man/man1/v4rcp.1*
%{prefix}/bin/v5passwd
%{prefix}/man/man1/v5passwd.1*
%{prefix}/bin/sim_client
%{prefix}/bin/uuclient
%{prefix}/sbin/login.krb5
%{prefix}/man/man8/login.krb5.8*
%{prefix}/sbin/ftpd
%{prefix}/man/man8/ftpd.8*
%{prefix}/sbin/gss-server
%{prefix}/sbin/klogind
%{prefix}/man/man8/klogind.8*
%{prefix}/sbin/kshd
%{prefix}/man/man8/kshd.8*
%{prefix}/sbin/telnetd
%{prefix}/man/man8/telnetd.8*
%{prefix}/sbin/uuserver
%{prefix}/man/man5/krb5.conf.5*

%files server
%defattr(-,root,root)
%config /etc/rc.d/init.d/krb5server
%doc doc/admin*.ps doc/admin*.html doc/krb425*.html doc/krb425*.ps doc/install*.ps doc/install*.html
%dir /var/kerberos/krb5kdc
/usr/info/krb5-admin.info*
/usr/info/krb5-install.info*
/usr/info/krb425.info*
%config(noreplace) /var/kerberos/krb5kdc/kdc.conf
%config(noreplace) /var/kerberos/krb5kdc/kadm5.acl
%{prefix}/man/man5/kdc.conf.5*
%{prefix}/sbin/kadmin.local
%{prefix}/man/man8/kadmin.local.8*
%{prefix}/sbin/kadmind
%{prefix}/man/man8/kadmind.8*
%{prefix}/sbin/kadmind4
%{prefix}/sbin/kdb5_util
%{prefix}/man/man8/kdb5_util.8*
%{prefix}/sbin/kprop
%{prefix}/man/man8/kprop.8*
%{prefix}/sbin/kpropd
%{prefix}/man/man8/kpropd.8*
%{prefix}/sbin/krb5-send-pr
%{prefix}/sbin/krb524d
%{prefix}/sbin/krb5kdc
%{prefix}/man/man8/krb5kdc.8*
%{prefix}/sbin/sim_server
%{prefix}/sbin/v5passwdd
# This is here for people who want to test their server, and also 
# included in devel package for similar reasons.
%{prefix}/bin/sclient
%{prefix}/man/man1/sclient.1*
%{prefix}/sbin/sserver
%{prefix}/man/man8/sserver.8*

%files libs
%defattr(-,root,root)
%{prefix}/lib/lib*.so*

%files configs
%defattr(-,root,root)
%config /etc/krb5.conf
%config /etc/rc.d/init.d/kdcrotate

%files devel
%defattr(-,root,root)
%doc doc/api doc/implement doc/kadm5 doc/kadmin doc/krb5-protocol doc/rpc
%{prefix}/include
%{prefix}/lib/lib*.a
%{prefix}/bin/sclient
%{prefix}/man/man1/sclient.1*
%{prefix}/sbin/sserver
%{prefix}/man/man8/sserver.8*

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
